/**
 * @param {import('ipfs-core-utils/multicodecs').Multicodecs} codecs
 * @param {import('../types').Options} config
 */
export function createObject(codecs: import('ipfs-core-utils/multicodecs').Multicodecs, config: import('../types').Options): {
    data: (cid: import("multiformats").CID, options?: (import("ipfs-core-types/dist/src").AbortOptions & import("ipfs-core-types/dist/src/utils").PreloadOptions & import("../types").HTTPClientExtraOptions) | undefined) => Promise<Uint8Array>;
    get: (cid: import("multiformats").CID, options?: (import("ipfs-core-types/dist/src").AbortOptions & import("ipfs-core-types/dist/src/utils").PreloadOptions & import("../types").HTTPClientExtraOptions) | undefined) => Promise<import("@ipld/dag-pb/src/interface").PBNode>;
    links: (cid: import("multiformats").CID, options?: (import("ipfs-core-types/dist/src").AbortOptions & import("ipfs-core-types/dist/src/utils").PreloadOptions & import("../types").HTTPClientExtraOptions) | undefined) => Promise<import("@ipld/dag-pb/src/interface").PBLink[]>;
    new: (options?: (import("ipfs-core-types/dist/src/object").NewObjectOptions & import("../types").HTTPClientExtraOptions) | undefined) => Promise<import("multiformats").CID>;
    put: (obj: import("@ipld/dag-pb/src/interface").PBNode, options?: (import("ipfs-core-types/dist/src/object").PutOptions & import("../types").HTTPClientExtraOptions) | undefined) => Promise<import("multiformats").CID>;
    stat: (cid: import("multiformats").CID, options?: (import("ipfs-core-types/dist/src").AbortOptions & import("ipfs-core-types/dist/src/utils").PreloadOptions & import("../types").HTTPClientExtraOptions) | undefined) => Promise<import("ipfs-core-types/dist/src/object").StatResult>;
    patch: {
        addLink: (cid: import("multiformats").CID, dLink: import("@ipld/dag-pb/src/interface").PBLink, options?: (import("ipfs-core-types/dist/src").AbortOptions & import("../types").HTTPClientExtraOptions) | undefined) => Promise<import("multiformats").CID>;
        appendData: (cid: import("multiformats").CID, data: Uint8Array, options?: (import("ipfs-core-types/dist/src").AbortOptions & import("../types").HTTPClientExtraOptions) | undefined) => Promise<import("multiformats").CID>;
        rmLink: (cid: import("multiformats").CID, dLink: string | import("@ipld/dag-pb/src/interface").PBLink, options?: (import("ipfs-core-types/dist/src").AbortOptions & import("../types").HTTPClientExtraOptions) | undefined) => Promise<import("multiformats").CID>;
        setData: (cid: import("multiformats").CID, data: Uint8Array, options?: (import("ipfs-core-types/dist/src").AbortOptions & import("../types").HTTPClientExtraOptions) | undefined) => Promise<import("multiformats").CID>;
    };
};
//# sourceMappingURL=index.d.ts.map